; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; append

; ---conformance---
; R5RS

; ---purpose---
; Append lists.

; ---args---
; A - list
; B... - lists to be appended

; ---keywords---
; APPEND function, lists, appending

; ---see-also---
; reverse, length, map, equal?, list?

; ---example---
; (append '(a b) '(c d) '(e f)) => '(a b c d e f)

(define append #t)

:c lib/reverse.l
:c lib/reduce.l

; ---code---
(define append (lambda (a . b)
	(letrec ((app2 (lambda (a b)
			(cond ((null? a) b)
				(#t (app2 (cdr a) (cons (car a) b))))))
		(app (lambda (a b)
			(app2 (reverse a) b))))
		(reduce app (cons a b) '()))))

