; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; char-alphabetic?

; ---conformance---
; R5RS

; ---purpose---
; Test whether a char is alphabetic.

; ---args---
; X - char

; ---keywords---
; CHAR-ALPHABETIC? function, chars, characters, property, case

; ---see-also---
; char-lower-case?, char-numeric?, char-whitespace?

; ---example---
; (char-alphabetic? #\c) => #t

(define char-alphabeticp #t)

:c lib/c-upper-casep.l char-upper-case?
:c lib/c-lower-casep.l char-lower-case?

; ---code---
(define char-alphabetic? (lambda (x)
	(cond ((char-lower-case? x) #t)
		(#t (char-upper-case? x)))))

