; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; char-ci<=?

; ---conformance---
; R5RS

; ---purpose---
; Case-insensitively test whether two chars are in
; lexically non-descending order.

; ---args---
; X - char
; Y - char

; ---keywords---
; CHAR-CI<=? function, chars, characters, comparison,
; lexical order, non-descending, case insensitive

; ---see-also---
; char<=?, char-ci<?, char-ci=?, char-ci>?, char-ci>=?, string<=?, equal?

; ---example---
; (char-ci<=? #\b #\B) => #t

(define char-cilep #t)

:c lib/c-cigtp.l char-ci>?
:c lib/not.l

; ---code---
(define char-ci<=? (lambda (x y)
	(not (char-ci>? x y))))

