; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; char-whitespace?

; ---conformance---
; R5RS

; ---purpose---
; Test whether a char is white space.

; ---args---
; X - char

; ---keywords---
; CHAR-WHITESPACE? function, chars, characters, property, case

; ---see-also---
; char-lower-case?, char-alphabetic?, char-numeric?

; ---example---
; (char-whitespace? #\space) => #t

(define char-whitespacep #t)

:c lib/ceqp.l char=?

; ---code---
(define char-whitespace? (lambda (x)
	(cond ((char=? x #\space) #t)				; blank
		((char=? x (integer->char 9)) #t)		; HT
		((char=? x (integer->char 10)) #t)		; LF
		((char=? x (integer->char 12)) #t)		; FF
		(#t (char=? x (integer->char 13))))))	; CR

