; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; caaar ... cdddr

; ---conformance---
; R5RS

; ---purpose---
; Access elements of nested lists.

; ---args---
; X - list

; ---keywords---
; CAAAR, CAADR, CADAR, CADDR
; CDAAR, CDADR, CDDAR, CDDDR
; lists, selector, decomposition

; ---see-also---
; caaaar, caar

; ---example---
; (caddr '(a b c d e f g h)) => 'c

; ---code---
(define caaar (lambda (x) (car (car (car x)))))
(define caadr (lambda (x) (car (car (cdr x)))))
(define cadar (lambda (x) (car (cdr (car x)))))
(define caddr (lambda (x) (car (cdr (cdr x)))))
(define cdaar (lambda (x) (cdr (car (car x)))))
(define cdadr (lambda (x) (cdr (car (cdr x)))))
(define cddar (lambda (x) (cdr (cdr (car x)))))
(define cdddr (lambda (x) (cdr (cdr (cdr x)))))

