; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; equal?

; ---conformance---
; R5RS

; ---purpose---
; Compare two S-expressions. Return #T,
; if both expressions print equal.

; ---args---
; A - expression
; B - expression

; ---keywords---
; EQUAL function, equivalence, relation, comparison, predicate

; ---see-also---
; member, =

; ---example---
; (equal? '(a b (c d (e)) f) '(a b (c d (e)) f)) => #t

(define equalp #t)

:c lib/lognand.l
:c lib/equal.l =
:c lib/ceqp.l char=?
:c lib/seqp.l string=?

; ---code---
(define equal? (lambda (a b)
	(cond ((number? a)
			(cond ((number? b) (= a b))
				(#t #f)))
		((char? a)
			(cond ((char? b) (char=? a b))
				(#t #f)))
		((string? a)
			(cond ((string? b) (string=? a b))
				(#t #f)))
		((lognand (pair? a) (pair? b))
			(eq? a b))
		((equal? (car a) (car b))
			(equal? (cdr a) (cdr b)))
		(#t #f))))

