; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; gcd

; ---conformance---
; R5RS
; Takes only two arguments.

; ---purpose---
; Compute the greatest common divisor (GCD) of two integer numbers.
; This function uses Euclid's Algorithm.

; ---args---
; A - number
; B - number

; ---keywords---
; GCD function, gcd, greatest common divisor
; Euclid, Euclid's algorithm, arithmetics

; ---see-also---
; digits, expt, lcm

; ---example---
; (gcd 99 -77) => 11

(define gcd #t)

:c lib/abs.l
:c lib/natural.l
:c lib/zerop.l zero?
:c lib/nremainder.l
:c lib/nless.l n<

; ---code---
(define gcd (lambda (a b)
	(letrec ((_gcd (lambda (a b)
			(cond ((zero? b) a)
				((n< a b) (_gcd a (nremainder b a)))
				(#t (_gcd b (nremainder a b)))))))
		(_gcd (natural (abs a)) (natural (abs b))))))

