; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; head?

; ---conformance---
; Sketchy Extension

; ---purpose---
; Check whether an expression X is the head of an
; expression Y.

; ---args---
; X - potential head
; Y - expression

; ---keywords---
; HEAD? function, list, pair, head

; ---see-also---
; tail?, caar, list?

; ---example---
; (headp '(a b c) '(a b c d e f)) => #t

(define headp #t)

:c lib/equalp.l equal?

; ---code---
(define headp (lambda (x y)
	(cond ((null? y) (null? x))
		((null? x) #t)
		((equal? (car x) (car y)) (headp (cdr x) (cdr y)))
		(#t #f))))

