; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; iterate

; ---conformance---
; Sketchy Core

; ---purpose---
; Iterate through a list. Combine the first member
; of the list with the second member, the result
; with the third member, etc.

; ---args---
; F - combining function
; A - list to iterate through

; ---keywords---
; ITERATE function, iteration

; ---see-also---
; map, maplist, reduce

; ---example---
; :l lib/minus.l
; (iterate - '(1 2 3 4)) => -8

; ---code---
(define iterate (lambda (f a)
	(letrec ((iter (lambda (a res)
			(cond ((null? a) res)
				(#t (iter (cdr a) (f res (car a))))))))
		(iter (cdr a) (car a)))))

