; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; lcm

; ---conformance---
; R5RS
; Takes only two arguments.

; ---purpose---
; Compute the least common multiple (LCM) of two integer numbers.

; ---args---
; A - number
; B - number

; ---keywords---
; LCM function, lcm, least common multiple, arithmetics

; ---see-also---
; digits, expt, gcd

; ---example---
; (lcm 32 -36) => 288

(define lcm #t)

:c lib/abs.l
:c lib/gcd.l
:c lib/nquotient.l
:c lib/ntimes.l n*
:c lib/natural.l

; ---code---
(define lcm (lambda (a b)
	(letrec ((cd (gcd a b)))
		(n* cd
			(n* (nquotient (natural (abs a)) cd)
				(nquotient (natural (abs b)) cd))))))

