; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; lognand

; ---conformance---
; Sketchy Core

; ---purpose---
; Logical negative product (NAND).

; ---args---
; A - truth value
; B - truth value

; ---keywords---
; LOGNAND function, NAND, logical negative AND
; logical negative product

; ---see-also---
; logand, logeqv, logneqv, lognor, lognot, logor

; ---example---
; (lognand #f #t) => #t

; ---code---
(define lognand (lambda (a b)
	(cond (a (eq? b #f))
		(#t #t))))

