; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; logneqv

; ---conformance---
; Sketchy Core

; ---purpose---
; Logical negative equivalence (XOR).

; ---args---
; A - truth value
; B - truth value

; ---keywords---
; LOGNEQV function, logical negative equivalence
; logical difference, logical XOR, logical exclusive OR

; ---see-also---
; logand, logeqv, lognand, lognor, lognot, logor

; ---example---
; (logneqv #t #f) => #t

; ---code---
(define logneqv (lambda (a b)
	(cond ((eq? a b) #f)
		(#t #t))))

