; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; lognor

; ---conformance---
; Sketchy Core

; ---purpose---
; Logical negative sum (NOR).

; ---args---
; A - truth value
; B - truth value

; ---keywords---
; LOGNOR function, NOR, logical negative OR
; logical negative sum

; ---see-also---
; logand, logeqv, lognand, logneqv, lognot, logor

; ---example---
; (lognor #f #f) => #t

; ---code---
(define lognor (lambda (a b)
	(cond (a #f)
		(#t (eq? b #f)))))

