; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; max

; ---conformance---
; R5RS

; ---purpose---
; Find the maximum of a list of numbers.

; ---args---
; A... - numbers

; ---keywords---
; MAX function, maximum, comparison, arithmetics

; ---see-also---
; digits, min, >

; ---example---
; (max -25 5 25 0 -5) => 25

(define max #t)

:c lib/caar.l cadr cddr
:c lib/greater.l >

; ---code---
(define max (lambda (a . b)
	(letrec ((max-list (lambda (a)
			(cond ((null? (cdr a)) (car a))
				((> (car a) (cadr a))
					(max-list (cons (car a) (cddr a))))
				(#t (max-list (cdr a)))))))
		(cond ((null? b) a)
			(#t (max-list (cons a b)))))))

