; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; member?

; ---conformance---
; Sketchy Extension

; ---purpose---
; Check whether a list has a member that is equal to a given
; S-expression. If such a member exists, return #T. If no such
; member is found, return #F.

; ---args---
; X - expression to find
; A - list

; ---keywords---
; MEMBER? function, member of, sets, set theory

; ---see-also---
; memq?, member

; ---example---
; (member? '(c d) '(a b (c d) e f)) => #t

(define memberp #t)

:c lib/equalp.l equal?

; ---model---
; (define member? (lambda (x a)
;	(cond ((null? a) #f)
;		((equal? (car a) x) #t)
;		(#t (member x (cdr a))))))

; ---code---
(define member? (lambda (x a)
	(letrec ((mem (lambda (a)
			(cond ((null? a) #f)
				((equal? (car a) x) #t)
				(#t (mem (cdr a)))))))
		(mem a))))

