; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; memq?

; ---conformance---
; Sketchy Extension

; ---purpose---
; Check whether a list has a member that is equal to a given
; symbol. If such a member exists, return #T. If no such
; member is found, return #F.

; ---args---
; X - symbol to find
; A - list

; ---keywords---
; MEMQ? function, member of, sets, set theory

; ---see-also---
; member?, memq

; ---example---
; (memq? 'c '(a b c d e f)) => #t

(define memqp #t)

; ---model---
; (define memq? (lambda (x a)
;	(cond ((null? a) #f)
;		((eq? (car a) x) #t)
;		(#t (member x (cdr a))))))

; ---code---
(define memq? (lambda (x a)
	(letrec ((mmq (lambda (a)
			(cond ((null? a) #f)
				((eq? (car a) x) #t)
				(#t (mmq (cdr a)))))))
		(mmq a))))

