; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; min

; ---conformance---
; R5RS

; ---purpose---
; Find the minimum of some numbers.

; ---args---
; A... - numbers

; ---keywords---
; MIN function, minimum, comparison, arithmetics

; ---see-also---
; digits, max, <

; ---example---
; (min 25 5 -25 0 -5) => -25

(define min #t)

:c lib/caar.l cadr cddr
:c lib/less.l <

; ---code---
(define min (lambda (a . b)
	(letrec ((min-list (lambda (a)
			(cond ((null? (cdr a)) (car a))
				((< (car a) (cadr a))
					(min-list (cons (car a) (cddr a))))
				(#t (min-list (cdr a)))))))
		(cond ((null? b) a)
			(#t (min-list (cons a b)))))))

