; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; modulo

; ---conformance---
; R5RS

; ---purpose---
; Compute the modulo of two numbers.

; ---args---
; A - number (dividend)
; B - number (divisor)

; ---keywords---
; MODULO function, division, remainder, division remainder
; modulus, arithmetics

; ---see-also---
; digits, remainder, quotient, divide, +, -, *

; ---example---
; (modulo 123 -23) => -15

(define modulo #t)

:c lib/remainder.l
:c lib/negativep.l negative?
:c lib/plus.l +

; ---code---
(define modulo (lambda (a b)
	(letrec ((rem (remainder a b)))
		(cond ((eq? (negative? a) (negative? b))
					rem)
			(#t
				(+ b rem))))))

