; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; neq?

; ---conformance---
; Sketchy Extension

; ---purpose---
; Negative identity. Test two atoms for being not identical.

; ---args---
; X - atom
; Y - atom

; ---keywords---
; NEQ function, negative identity

; ---see-also---
; not-equal?, equal?

; ---example---
; (neq? 'a 'b) => #t

(define neqp #t)

; ---code---
(define neq? (lambda (x y)
	(cond ((eq? x y) #f)
		(#t #t))))

