; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; one?

; ---conformance---
; Sketchy Extension

; ---purpose---
; Test a number for being one.

; ---args---
; X - number

; ---keywords---
; ONEP function, one , numbers, digit, equivalence
; identity, predicate

; ---see-also---
; digits, zero?, even?, negative?

; ---example---
; (one? 1) => #t

(define onep #t)

:c lib/digits.l 1-digit
:c lib/equal.l =

; ---code---
(define one? (lambda (x)
	(letrec ((onep (lambda (list-x)
			(cond ((eq? (car list-x) 1-digit) (null? (cdr list-x)))
				(#t (= x 1))))))
		(onep (integer->list x)))))

