; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; pair

; ---conformance---
; Sketchy Extension

; ---purpose---
; Build an association list from two lists.

; ---args---
; X - list containing keys
; Y - list containing values

; ---keywords---
; PAIR function, assocation lists, alists, associate

; ---see-also---
; assoc

; ---example---
; (pair '(1 2 3) '(i ii iii)) => '((1.i) (2.ii) (3.iii))

(define pair #t)

:c lib/reverse.l

; ---model---
; (define pair (lambda (x y)
;	(cond ((null? x) '())
;		((null? y) '())
;		(#t (cons (cons (car x) (car y)) (pair (cdr x) (cdr y)))))))

; ---code---
(define pair (lambda (x y)
	(letrec ((par (lambda (x y r)
			(cond ((null? x) r)
				((null? y) r)
				(#t (par (cdr x) (cdr y)
						(cons (cons (car x) (car y)) r)))))))
		(reverse (par x y '())))))

