; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; positive?

; ---conformance---
; R5RS

; ---purpose---
; Check whether a number is positive.

; ---args---
; X - number

; ---keywords---
; POSITIVE? function, positive value, sign, predicate, numbers

; ---see-also---
; digits, negative?, zero?, abs

; ---example---
; (positive? 567) => #t

(define positivep #t)

:c lib/digits.l
:c lib/lognor.l
:c lib/zerop.l zero?
:c lib/negativep.l negative?

; ---code---
(define positive? (lambda (x)
	(lognor (negative? x) (zero? x))))

