; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; string-append

; ---conformance---
; R5RS

; ---purpose---
; Append strings.

; ---args---
; A - string
; B... - strings to be appended

; ---keywords---
; STRING-APPEND function, strings, appending

; ---see-also---
; string, string-length, string-ref, append

; ---example---
; (string-append "He" "llo " "World") => "Hello World"

(define string-append #t)

:c lib/reduce.l
:c lib/append.l

; ---code---
(define string-append (lambda (a . b)
	(letrec ((appstr (lambda (a b)
			(list->string (append (string->list a)
				(string->list b))))))
		(reduce appstr (cons a b) ""))))

