; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; string<=?

; ---conformance---
; R5RS

; ---purpose---
; Test whether two strings are in non-descending lexical order.

; ---args---
; X - string
; Y - string

; ---keywords---
; STRING<=? function, strings, comparison, lexical order,
; non-descending

; ---see-also---
; string-ci<=?, string<?, string=?, string>?, string>=?, char<=?, equal?

; ---example---
; (string<=? "abc" "abc") => #t

(define stringlep #t)

:l lib/not.l
:l lib/sgtp.l string>?

; ---code---
(define string<=? (lambda (x y)
	(not (string>? x y))))

