; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; sort

; ---conformance---
; Sketchy Extension

; ---purpose---
; Sort a list. A predicate is used to define the
; desired order of members. It should return #T
; for each two members in the desired order.
; SORT is merely an alias for QUICKSORT.

; ---args---
; A - list to sort
; P - predicate

; ---keywords---
; SORT function, sorting, ordering, quicksort

; ---see-also---
; isort, quicksort, ordered?, unsort

; ---example---
; :l lib/less.l
; (sort '(5 1 3 2 4) <) => '(1 2 3 4 5)

(define sort #t)

:c lib/quicksort.l

; ---code---
(define sort quicksort)

