; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; succ

; ---conformance---
; Sketchy Core

; ---purpose---
; Find the successor of a decimal digit.
; -
; (SUCC 9) => NIL

; ---args---
; X - digit

; ---keywords---
; SUCC function, successor, numbers, digits

; ---see-also---
; digits, pred

; ---example---
; (succ 3-digit) => '4-digit

:c lib/digits.l 0-digit 1-digit 2-digit 3-digit 4-digit 5-digit 6-digit 7-digit 8-digit 9-digit

; ---code---
(define succ (lambda (x)
	(cond ((eq? x 0-digit) 1-digit)
		((eq? x 1-digit) 2-digit)
		((eq? x 2-digit) 3-digit)
		((eq? x 3-digit) 4-digit)
		((eq? x 4-digit) 5-digit)
		((eq? x 5-digit) 6-digit)
		((eq? x 6-digit) 7-digit)
		((eq? x 7-digit) 8-digit)
		((eq? x 8-digit) 9-digit)
		((eq? x 9-digit) '())
		(#t (bottom 'type-error)))))

