; SketchyLISP Example Program
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---purpose---
; Solve the 'Towers of Hanoi'.

; ---args---
; N - list containing one member per disk

; ---keywords---
; HANOI function, Towers of Hanoi, example

; ---example---
; (hanoi '(i i i)) => '((a b) (a c) (b c) (a b) (c a) (c b) (a b))

:l lib/list.l
:l lib/append.l

; ---code---
(define hanoi (lambda (n)
	(letrec ((_hanoi (lambda (from to via n)
			(cond ((null? n) '())
				(#t (append
						(_hanoi from via to (cdr n))
						(list (list from to))
						(_hanoi via to from (cdr n))))))))
		(_hanoi 'a 'b 'c n))))

