#!/bin/sh

basedir="/usr/local"

if [ "$1" = "-update" -o "$1" = "--update" ]; then
	echo '2' >$HOME/sketchy/.version
	cp $basedir/share/sketchy/lib/*.l $HOME/sketchy/lib
	echo
	echo "Your SketchyLISP library files in $HOME/sketchy/lib"
	echo "have been udated."
	echo
	echo -n \
	"Replace the example files in your $HOME/sketchy/src directory? (y/n) "
	read x
	echo
	case $x in
		y|yes|Y|Yes|YES)
			cp $basedir/share/sketchy/src/*.[lm] $HOME/sketchy/src
			echo \
			"Your $HOME/sketchy/src directory has been updated."
			echo
			;;
	esac
	exit 0
fi

if [ -d $HOME/sketchy ]; then
	echo
	echo "Your SketchyLISP environment is already set up."
	echo "Its base directory is $HOME/sketchy."
	echo
	echo "You may run sketchy_install with the --update"
	echo "option to update the library files."
	echo
	exit 1
fi

mkdir $HOME/sketchy
mkdir $HOME/sketchy/lib
mkdir $HOME/sketchy/src

cp $basedir/share/sketchy/lib/*.l $HOME/sketchy/lib
cp $basedir/share/sketchy/src/*.[lm] $HOME/sketchy/src

echo '13' >$HOME/sketchy/.version

echo
echo "Your SketchyLISP base directory is $HOME/sketchy."
echo

